Puzzle
App · 25 actions
Read company accounting data, transactions, journal entries, bills, invoices, accounts, customers, vendors, statements and financial metrics.
Actions
| Action | What it does |
|---|---|
| Get Balance Sheet Statement | Get Balance Sheet Statement. |
| Get Bill | Get Bill. |
| Get Bills | Get Bills. |
| Get Cash Activity Statement | Get Cash Activity Statement. |
| Get Chart of Accounts | Get Chart of Accounts. |
| Get companies | Get companies. |
| Get Company | Get Company. |
| Get Current User | Get Current User. |
| Get Customers | Get Customers. |
| Get Expense Metrics | Get Expense Metrics. |
| Get Financial Account Balances | Get Financial Account Balances. |
| Get Financial Accounts | Get Financial Accounts. |
| Get Income Statement | Get Income Statement. |
| Get Invoice | Get Invoice. |
| Get Invoices | Get Invoices. |
| Get Journal Entries | Get Journal Entries. |
| Get Ledger Account | Get Ledger Account. |
| Get Puzzle Categories | Get Puzzle Categories. |
| Get Requests | Get Requests. |
| Get Revenue Metrics | Get Revenue Metrics. |
| Get Spending Metrics | Get Spending Metrics. |
| Get Tasks | Get Tasks. |
| Get Transaction | Get Transaction. |
| Get Transactions | Get Transactions. |
| Get Vendors | Get Vendors. |
Get Balance Sheet Statement
Get Balance Sheet Statement.
Inputs
- Company
idtextRequired - The company ID
- Basis
basistext - The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of:
cash,accrual. - ViewBy
viewBytext - The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of:
month,quarter,year,totals,departments. - StartPeriod
startPeriodtext - Startperiod
- EndPeriod
endPeriodtext - Endperiod
- DateMacro
dateMacrotext - DatemacroOne of:
CurrentMonth,LastFullMonth,LastThreeMonths,LastThreeFullMonths,CurrentYear,LastYear,QuarterToDate,YearToDate.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"columns": [],
"lines": []
},
"has_more": false,
"next_cursor": "example"
}Get Bill
Get Bill.
Inputs
- Company
idtextRequired - The company ID
- BillId
billIdtextRequired - The bill ID
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"amount": null,
"currentness": "Current",
"description": null,
"documents": [],
"dueDate": null,
"externalId": null,
"id": "example",
"issueDate": "example",
"lines": [],
"paidAt": null,
"provider": null,
"status": "Deleted",
"submittedAt": null,
"userId": "example",
"vendorId": "example",
"voidedAt": null
},
"has_more": false,
"next_cursor": "example"
}Get Bills
Get Bills.
Inputs
- Company
idtextRequired - The company ID
- IsLinked
isLinkedtext - Boolean flag; "true" enables, any other value disables
- IsPaid
isPaidtext - Boolean flag; "true" enables, any other value disables
- IsSubmitted
isSubmittedtext - Boolean flag; "true" enables, any other value disables
- IsVoided
isVoidedtext - Boolean flag; "true" enables, any other value disables
- MinAmount
minAmounttext - Arbitrary-precision decimal, serialized as a string
- MaxAmount
maxAmounttext - Arbitrary-precision decimal, serialized as a string
- From value
from_valuetext - Calendar date, YYYY-MM-DD
- To
totext - Calendar date, YYYY-MM-DD
- DueDateFrom
dueDateFromtext - Calendar date, YYYY-MM-DD
- DueDateTo
dueDateTotext - Calendar date, YYYY-MM-DD
- Statuses
statusestext - StatusesOne of:
Draft,Voided,Paid,Unpaid,Current,Overdue. - VendorIds
vendorIdstext - Partner-facing external identifier
- SortBy
sortBytext - SortbyOne of:
AMOUNT_DESC,AMOUNT_ASC,DESCRIPTOR_DESC,DESCRIPTOR_ASC,DUE_DATE_DESC,DUE_DATE_ASC,ISSUE_DATE_DESC,ISSUE_DATE_ASC,VENDOR_DESC,VENDOR_ASC. - Count
countnumber - Count
- After
aftertext - After
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"items": [],
"pageInfo": {
"endCursor": null,
"hasNextPage": false,
"total": null
},
"total": {
"amount": "example",
"currency": "example"
}
},
"has_more": false,
"next_cursor": "example"
}Get Cash Activity Statement
Get Cash Activity Statement.
Inputs
- Company
idtextRequired - The company ID
- ViewBy
viewBytext - The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of:
month,quarter,year,totals,departments. - StartPeriod
startPeriodtext - Startperiod
- EndPeriod
endPeriodtext - Endperiod
- DateMacro
dateMacrotext - DatemacroOne of:
CurrentMonth,LastFullMonth,LastThreeMonths,LastThreeFullMonths,CurrentYear,LastYear,QuarterToDate,YearToDate.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"columns": [],
"lines": []
},
"has_more": false,
"next_cursor": "example"
}Get Chart of Accounts
Get Chart of Accounts.
Inputs
- Company
idtextRequired - The company ID
- Basis
basistext - BasisOne of:
cash,accrual. - StartDate
startDatedate - Startdate
- EffectiveDate
effectiveDatetext - Calendar date, YYYY-MM-DD
- NominalCode
nominalCodetext - Nominalcode
- GetRestricted
getRestrictedtext - Boolean flag; "true" enables, any other value disables
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"accounts": []
},
"has_more": false,
"next_cursor": "example"
}Get companies
Get companies.
Inputs
- Limit
limitnumber - Page size for modern client credentials (default 100, maximum 100); ignored for OAuth and upstream users.From 1 to 100.
- Cursor
cursortext - Pagination cursor for modern client credentials; ignored for OAuth and upstream users.
- Include
includetext - Adds integrationHealth to each company. Requires puzzle-client-id, Authorization: Bearer <client secret>, read:company, an active firm authorization and a nonremoved firm-client link. Ignored for OAuth and upstream users.One of:
integration_health.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"companies": [],
"nextCursor": null
},
"has_more": false,
"next_cursor": "example"
}Get Company
Get Company.
Inputs
- Company
idtextRequired - The company ID
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"financialSummary": null,
"id": "example",
"institutionConnections": [],
"metadata": null,
"name": "example",
"status": "Ready"
},
"has_more": false,
"next_cursor": "example"
}Get Current User
Get Current User.
Inputs
None.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"companies": [],
"id": "example"
},
"has_more": false,
"next_cursor": "example"
}Get Customers
Get Customers.
Inputs
- Company
idtextRequired - The company ID
- Name
nametext - Name
- Type
typetext - TypeOne of:
Individual,Business,Unknown. - Status
statustext - StatusOne of:
Active,Inactive,Unknown. - Count
countnumber - Count
- After
aftertext - After
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"items": [],
"pageInfo": {
"endCursor": null,
"hasNextPage": false,
"total": null
}
},
"has_more": false,
"next_cursor": "example"
}Get Expense Metrics
Get Expense Metrics.
Inputs
- Company
idtextRequired - The company ID
- StartDate
startDatedateRequired - Calendar date, YYYY-MM-DD
- EndDateExclusive
endDateExclusivetext - Calendar date, YYYY-MM-DD
- Interval
intervaltext - The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of:
month.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"metrics": []
},
"has_more": false,
"next_cursor": "example"
}Get Financial Account Balances
Get Financial Account Balances.
Inputs
- Company
idtextRequired - The company ID
- Dates
datesdateRequired - Date to retrieve account balances for.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"balancesByDate": []
},
"has_more": false,
"next_cursor": "example"
}Get Financial Accounts
Get Financial Accounts.
Inputs
- Company
idtextRequired - The company ID
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"accounts": []
},
"has_more": false,
"next_cursor": "example"
}Get Income Statement
Get Income Statement.
Inputs
- Company
idtextRequired - The company ID
- Basis
basistext - The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of:
cash,accrual. - ViewBy
viewBytext - The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of:
month,quarter,year,totals,departments. - StartPeriod
startPeriodtext - Startperiod
- EndPeriod
endPeriodtext - Endperiod
- DateMacro
dateMacrotext - DatemacroOne of:
CurrentMonth,LastFullMonth,LastThreeMonths,LastThreeFullMonths,CurrentYear,LastYear,QuarterToDate,YearToDate. - Departments
departmentstext - One or more cls_ classification segment IDs returned by GET /company/{id}/classifications, or the case-insensitive literal "none". Values may be repeated or comma-separated.
- Locations
locationstext - One or more cls_ classification segment IDs returned by GET /company/{id}/classifications, or the case-insensitive literal "none". Values may be repeated or comma-separated.
- ExpandCounterparties
expandCounterpartiestext - Boolean flag; "true" enables, any other value disables
- ExpandRevenueSources
expandRevenueSourcestext - Boolean flag; "true" enables, any other value disables
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"columns": [],
"lines": []
},
"has_more": false,
"next_cursor": "example"
}Get Invoice
Get Invoice.
Inputs
- Company
idtextRequired - The company ID
- InvoiceId
invoiceIdtextRequired - The invoice ID
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"amount": {
"amount": "example",
"currency": "example"
},
"contractId": null,
"customerId": null,
"description": null,
"documents": [],
"dueDate": null,
"id": "example",
"issueDate": null,
"lines": [],
"nativeId": null,
"status": "Deleted"
},
"has_more": false,
"next_cursor": "example"
}Get Invoices
Get Invoices.
Inputs
- Company
idtextRequired - The company ID
- From value
from_valuetext - Calendar date, YYYY-MM-DD
- To
totext - Calendar date, YYYY-MM-DD
- CustomerIds
customerIdstext - Partner-facing external identifier
- Statuses
statusestext - StatusesOne of:
Deleted,Draft,Posted,Voided,Paid. - CoaKeys
coaKeystext - Chart-of-accounts key
- IsPaid
isPaidtext - Boolean flag; "true" enables, any other value disables
- MinAmount
minAmounttext - Arbitrary-precision decimal, serialized as a string
- MaxAmount
maxAmounttext - Arbitrary-precision decimal, serialized as a string
- SortBy
sortBytext - SortbyOne of:
AMOUNT_DESC,AMOUNT_ASC,CUSTOMER_DESC,CUSTOMER_ASC,DESCRIPTOR_DESC,DESCRIPTOR_ASC,DUE_DATE_DESC,DUE_DATE_ASC,ISSUE_DATE_DESC,ISSUE_DATE_ASC. - Count
countnumber - Count
- After
aftertext - After
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"items": [],
"pageInfo": {
"endCursor": null,
"hasNextPage": false,
"total": null
},
"total": {
"amount": "example",
"currency": "example"
}
},
"has_more": false,
"next_cursor": "example"
}Get Journal Entries
Get Journal Entries.
Inputs
- Company
idtextRequired - The company ID
- Limit
limitnumber - Limit
- Cursor
cursortext - Cursor
- Basis
basistext - BasisOne of:
cash,accrual. - CreatedAfter
createdAfterdate and time - ISO 8601 timestamp
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"journalEntries": [],
"pageInfo": {
"nextCursor": null
}
},
"has_more": false,
"next_cursor": "example"
}Get Ledger Account
Get Ledger Account.
Inputs
- Company
idtextRequired - The company ID
- LedgerAccountId
ledgerAccountIdtextRequired - The ledger account ID
- Basis
basistext - BasisOne of:
cash,accrual.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"accountId": null,
"category": "example",
"coaKeys": [],
"currentBalance": {
"amount": "example",
"currency": "example"
},
"currentBalanceWithoutSubAccounts": {
"amount": "example",
"currency": "example"
},
"currentness": null,
"description": null,
"id": "example",
"isBankAccount": false,
"keywords": [],
"name": "example",
"nominalCode": "example",
"parentCode": null,
"restrictedCoaKeys": [],
"subCategory": null,
"tags": [],
"tertiaryCategory": null,
"type": "example",
"views": []
},
"has_more": false,
"next_cursor": "example"
}Get Puzzle Categories
Get Puzzle Categories.
Inputs
None.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"categories": []
},
"has_more": false,
"next_cursor": "example"
}Get Requests
Get Requests.
Inputs
- Company
idtextRequired - The company ID
- Status
statustext - Status
- Type
typetext - Type
- TransactionIds
transactionIdstext - Partner-facing external identifier
- RequestedUserIds
requestedUserIdstext - Partner-facing external identifier
- RequestedByUserIds
requestedByUserIdstext - Partner-facing external identifier
- StartDate
startDatedate - Calendar date, YYYY-MM-DD
- EndDate
endDatedate - Calendar date, YYYY-MM-DD
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"requests": []
},
"has_more": false,
"next_cursor": "example"
}Get Revenue Metrics
Get Revenue Metrics.
Inputs
- Company
idtextRequired - The company ID
- StartDate
startDatedateRequired - Calendar date, YYYY-MM-DD
- EndDateExclusive
endDateExclusivetext - Calendar date, YYYY-MM-DD
- Interval
intervaltext - The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of:
month.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"metrics": []
},
"has_more": false,
"next_cursor": "example"
}Get Spending Metrics
Get Spending Metrics.
Inputs
- Company
idtextRequired - The company ID
- StartDate
startDatedateRequired - Calendar date, YYYY-MM-DD
- EndDateExclusive
endDateExclusivetext - Calendar date, YYYY-MM-DD
- Interval
intervaltext - The value is normalized before matching, so any casing that maps onto a listed value is accepted.One of:
month.
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"endPeriod": "example",
"nonPayrollMetrics": [],
"payrollMetrics": [],
"startPeriod": "example"
},
"has_more": false,
"next_cursor": "example"
}Get Tasks
Get Tasks.
Inputs
- Company
idtextRequired - The company ID
- Status
statustext - Status
- Type
typetext - Type
- AssigneeIds
assigneeIdstext - Partner-facing external identifier
- TransactionIds
transactionIdstext - Partner-facing external identifier
- CreatedBy
createdBytext - Partner-facing external identifier
- CreatedAfter
createdAfterdate and time - ISO 8601 timestamp
- Count
countnumber - Count
- After
aftertext - After
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"items": [],
"pageInfo": {
"endCursor": null,
"hasNextPage": false,
"total": null
}
},
"has_more": false,
"next_cursor": "example"
}Get Transaction
Get Transaction.
Inputs
- IncludeCategorization
includeCategorizationtext - Include categorization attribution and history only when "true"; omitted by default
- Company
idtextRequired - The company ID
- TransactionId
transactionIdtextRequired - The transaction ID
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"accountId": null,
"actorType": "SYSTEM_ACTOR",
"amount": {
"amount": "example",
"currency": "example"
},
"categorization": {
"confirmationStatus": "CONFIRMED",
"confirmedAt": null,
"details": [],
"detailsConfirmationStatus": "CONFIRMED",
"lastHumanConfirmation": null,
"status": "CATEGORIZED"
},
"category": null,
"classifications": null,
"coaKey": null,
"customerId": null,
"descriptor": "example",
"documents": null,
"id": "example",
"memo": null,
"nativeId": null,
"status": "Finalized",
"timestamp": "example",
"vendorId": null
},
"has_more": false,
"next_cursor": "example"
}Get Transactions
Get Transactions.
Inputs
- IncludeCategorization
includeCategorizationtext - Include categorization attribution and history only when "true"; omitted by default
- Company
idtextRequired - The company ID
- StartDate
startDatedateRequired - Calendar date, YYYY-MM-DD
- EndDate
endDatedateRequired - Calendar date, YYYY-MM-DD
- AccountIds
accountIdstext - Partner-facing external identifier
- VendorIds
vendorIdstext - Partner-facing external identifier
- CoaKeys
coaKeystext - Coakeys
- Status
statustext - StatusOne of:
Finalized,NotFinalized,NotCategorized. - SortBy
sortBytext - SortbyOne of:
ABS_AMOUNT_ASC,ABS_AMOUNT_DESC,AMOUNT_ASC,AMOUNT_DESC,DATE_ASC,DATE_DESC,DESCRIPTION_ASC,DESCRIPTION_DESC,NAME_ASC,UNCATEGORIZED_AMOUNT_DESC,VENDOR_ASC,VENDOR_DESC. - After
aftertext - After
- Count
countnumber - Count
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"items": [],
"pageInfo": {
"endCursor": null,
"hasNextPage": false,
"total": null
}
},
"has_more": false,
"next_cursor": "example"
}Get Vendors
Get Vendors.
Inputs
- Company
idtextRequired - The company ID
- Type
typetext - TypeOne of:
Individual,Business,Unknown. - Status
statustext - StatusOne of:
Active,Inactive,Unknown. - PermaNames
permaNamestext - Permanames
- Is1099Vendor
is1099Vendortext - Boolean flag; "true" enables, any other value disables
- Count
countnumber - Count
- After
aftertext - After
Outputs
dataobject- The response returned by the service.
has_moretrue/false- Whether another page is available.
next_cursortext- Continuation token for the next page.
Example output
{
"data": {
"items": [],
"pageInfo": {
"endCursor": null,
"hasNextPage": false,
"total": null
}
},
"has_more": false,
"next_cursor": "example"
}